<?php 
##################################################################
#                                                                #
#  ████   ████   ████  █   ██ ██████ ████   ██████  ████  █   ██ #
#   ██   ██  ██ ██  ██ ██  ██ ██      ██    ██     ██  ██ ██  ██ #
#   ██   ██     ██  ██ ███ ██ ██      ██    ██     ██  ██ ███ ██ #
#   ██   ██     ██  ██ ██████ █████   ██    █████  ██  ██ ██████ #
#   ██   ██     ██  ██ ██ ███ ██      ██    ██     ██  ██ ██ ███ #
#   ██   ██  ██ ██  ██ ██  ██ ██      ██ ██ ██     ██  ██ ██  ██ #
#  ████   ████   ████  ██   █ ██████ ██████ ██████  ████  ██   █ #
#                                                                #
##################################################################
# Author  : bronco@warriordudimanche.net
# Licence : MIT
# to add icons, just copy them in the icon folder (you can put them in a subfolder)
# in order to colorize the icon, the svg must contains a <path (the api will replace it with <path fill="[color]")


########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################
define('DEFAULT_COLOR','black');
define('VERSION',1.1);
if (!is_dir('rendered')){mkdir('rendered');}

##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
function search($string=null){
	$folders=glob('icons/*');
	$iconlist=[];
	foreach ($folders as $folder) {
		$iconlist= array_merge($iconlist,glob($folder.'/*.svg'));
	}
	if ($string){
		foreach ($iconlist as $icon) {
			if (stripos($icon, $string)!==false){
				$result[]=str_replace('icons/','',$icon);
			}
		}
		return $result;
	}else{
		foreach ($iconlist as $index=>$icon) {
			$iconlist[$index]=str_replace('icons/','',$icon);
		}
		return $iconlist;
	}
}

function sanitizeData($data=null){
        if (is_string($data)){
            $filters=[FILTER_VALIDATE_INT,FILTER_VALIDATE_FLOAT,FILTER_VALIDATE_URL,FILTER_VALIDATE_EMAIL,FILTER_VALIDATE_IP,FILTER_VALIDATE_BOOLEAN];
            $valid=false;
            foreach($filters as $filter){
                if ($valid=filter_var($data,$filter)){break;}
            }
            if (!$valid){
                return str_replace(["\0",'\\','[',']','{','}',';',':','$'],'',htmlentities(strip_tags($data), ENT_QUOTES));
            }
        }else if (is_array($data)){
            return array_map('sanitizeData',$data);
        }
        return $data;
    }

########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}

if (isset($_GET['download'])){	
	header('Content-Type: application/octet-stream');
    header('Content-Length: '.filesize('index.php'));
    header('Content-disposition: attachment; filename=index.php');
    header('Pragma: no-cache');
    header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
    header('Expires: 0');
    readfile('index.php');
    exit();
}

if (isset($_GET['iconlist'])){
	$iconlist=search();
	exit(json_encode($iconlist));
}

if (!empty($_GET['search'])){
	$iconlist=search($_GET['search']);
	exit(json_encode($iconlist));
}

if (!empty($_GET['c'])){
	define('COLOR',sanitizeData($_GET['c']));
}else{
	define('COLOR',DEFAULT_COLOR);
}

if (!empty($_GET['i'])){
	# first, try to locate the icon
	if (is_file('icons/'.$_GET['i'])){
		# the name is full
		define('ICON',$_GET['i']);
	}else{
		# the user provides a partial string, get the first matching icon
		$iconslist=search($_GET['i']);
		if (!empty($iconslist)){
			define('ICON',$iconslist[0]);
		}

	}

	if (COLOR==DEFAULT_COLOR){
		# return the icon without color
		header('Content-type: image/svg+xml');
		exit(file_get_contents('icons/'.ICON));
	}

	define('ICON_FILE','rendered/'.str_replace('/','/'.COLOR.'-',ICON));

	# checks the path to create folders if needed 
	$path=pathinfo(ICON_FILE)["dirname"];
	if (!is_dir($path)){mkdir($path);}

	# is this icon already rendered in that color ?
	if (is_file(ICON_FILE)){
		header('Content-type: image/svg+xml');
		exit(file_get_contents(ICON_FILE));
	}else{
		# generate a colored version of the icon
		$icon=file_get_contents('icons/'.ICON);
		$icon=str_replace('<path','<path fill="'.COLOR.'"',$icon);
		file_put_contents(ICON_FILE, $icon);
		header('Content-type: image/svg+xml');
		exit($icon);
	}
}
?><!DOCTYPE html>
<html>
<head>
	<title>Iconeleon</title>
	<meta charset="utf-8">

</head>
<body>
<main>
	<div class=""
</main>
</body>
</html>